.186
code segment
  assume cs:code
  org 100h
a:
  jmp c

r db 0
g db 0
b db 0

winlogo label byte
include winlogo.inc

sine label byte
include sin.inc

movies label byte
include movies.inc

lengths label byte
include lengths.inc

c:
  mov ax, 13h
  int 10h

  mov ax, 0A000h
  mov es, ax
  mov bh, 0
  mov ch, 0

  mov cl, 15
l:
  mov al, cl
  call SetRGB
  loop l
  mov cx, 32000
  mov ax, 3084
  rep stosw
  mov ch, 0

  call put
  mov dl, 0
  call pal12
  pusha
  mov dx, 0
e:
  mov cl, 6
q:
  call line
  loop q
  call VertRet
  mov ah, 01
  int 16h
  jnz w
  inc dl
  cmp dl, 120
  jne e
  mov dl, 0
  jmp e

w:
  popa
  mov dl, 63
  call pal12
  call exit

line proc near
  pusha
  mov ah, 0
  dec cl
  mov si, cx
  mov al, movies[si]
  add al, dl
  cmp al, 120
  jna next
  sub al, 120
next:
  mov si, ax
  mov al, sine[si]
  mov bx, 320
  mul bx
  mov di, ax
  add di, 50
  mov ah, 0
  mov si, cx
  mov al, movies[si]
  mov si, offset winlogo
  add si, ax
  add di, ax
  mov bh, 0
  mov bl, cl
  mov cl, 173
o:
  push cx
  push si
  mov si, bx
  mov al, lengths[si]
  mov cl, al
  pop si
  rep movsb
  sub di, ax
  sub si, ax
  add si, 220
  add di, 320
  pop cx
  loop o
  popa
  ret
line endp

pal12 proc near
  mov ah, 0
m:
  mov al, 15
  mov r, cl
  mov g, cl
  mov b, cl
  call SetRGB
  mov al, 8
  shr r, 1
  shr g, 1
  shr b, 1
  call SetRGB
  mov al, 12
  mov r, 0
  mov g, 0
  call SetRGB
  mov al, cl
  mov bl, 3
  div bl
  mov ah, 0
  shl al, 1
  mov r, al
  mov g, al
  mov b, al
  mov al, 7
  call SetRGB
;  call VertRet
  call VertRet
  cmp dl, 63
  jb incr
  dec cl
  cmp cl, 0
  jmp ex
incr:
  inc cl
  cmp cl, 63
ex:
  jne m
  ret
pal12 endp

put proc near
  pusha
  mov si, offset winlogo
  mov di, 4210
  mov cx, 173
n:
  push cx
  mov cx, 220
  rep movsb
  add di, 100
  pop cx
  loop n
  popa
  ret
put endp

VertRet proc near
        pusha
        mov dx,03DAh
@1:     in al,dx
        test al,8
        jz @1
@2:     in al,dx
        test al,8
        jnz @2
        popa
        ret
VertRet endp

exit proc near
  mov ax, 3
  int 10h
  mov ah, 4Ch
  int 21h
  ret
exit endp

SetRGB proc near
  pusha
  mov  dx, 03C8h
  out  dx, al
  inc  dx
  mov  al, r
  out  dx, al
  mov  al, g
  out  dx, al
  mov  al, b
  out  dx, al
  popa
  ret
SetRGB endp

code ends
  end a